// Copyright The prometheus-operator Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

// AlertmanagerWebSpecApplyConfiguration represents a declarative configuration of the AlertmanagerWebSpec type for use
// with apply.
type AlertmanagerWebSpecApplyConfiguration struct {
	WebConfigFileFieldsApplyConfiguration `json:",inline"`
	GetConcurrency                        *uint32 `json:"getConcurrency,omitempty"`
	Timeout                               *uint32 `json:"timeout,omitempty"`
}

// AlertmanagerWebSpecApplyConfiguration constructs a declarative configuration of the AlertmanagerWebSpec type for use with
// apply.
func AlertmanagerWebSpec() *AlertmanagerWebSpecApplyConfiguration {
	return &AlertmanagerWebSpecApplyConfiguration{}
}

// WithTLSConfig sets the TLSConfig field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the TLSConfig field is set to the value of the last call.
func (b *AlertmanagerWebSpecApplyConfiguration) WithTLSConfig(value *WebTLSConfigApplyConfiguration) *AlertmanagerWebSpecApplyConfiguration {
	b.TLSConfig = value
	return b
}

// WithHTTPConfig sets the HTTPConfig field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the HTTPConfig field is set to the value of the last call.
func (b *AlertmanagerWebSpecApplyConfiguration) WithHTTPConfig(value *WebHTTPConfigApplyConfiguration) *AlertmanagerWebSpecApplyConfiguration {
	b.HTTPConfig = value
	return b
}

// WithGetConcurrency sets the GetConcurrency field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the GetConcurrency field is set to the value of the last call.
func (b *AlertmanagerWebSpecApplyConfiguration) WithGetConcurrency(value uint32) *AlertmanagerWebSpecApplyConfiguration {
	b.GetConcurrency = &value
	return b
}

// WithTimeout sets the Timeout field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Timeout field is set to the value of the last call.
func (b *AlertmanagerWebSpecApplyConfiguration) WithTimeout(value uint32) *AlertmanagerWebSpecApplyConfiguration {
	b.Timeout = &value
	return b
}
